#pragma once
// IWYU pragma: private, include <quark.hpp>

#include "Window.hpp"
#include "quark/Layer.hpp"
#include "quark/LayerStack.hpp"
#include "quark/events/ApplicationEvent.hpp"

namespace qk {

	class Application {
	public:
		Application();
		virtual ~Application() {}

		void Run();

		void OnEvent(Event& e);

		void PushLayer(Layer* layer);
		void PushOverlay(Layer* layer);

	private:
		bool OnWindowClose(WindowCloseEvent& e);

	private:
		std::unique_ptr<Window> window;
		bool isRunning = true;

		LayerStack layers;
	};

	std::unique_ptr<qk::Application> CreateApplication();

}
